---

 Microline/XmL/Folder.c              |   13 ++++++-
 Microline/XmL/Makefile.common       |    2 -
 Microline/XmL/Makefile.dependencies |    4 ++
 source/window.c                     |   61 ++++++++++++++++++++++++++----------
 4 files changed, 61 insertions(+), 19 deletions(-)

diff --quilt old/Microline/XmL/Folder.c new/Microline/XmL/Folder.c
--- old/Microline/XmL/Folder.c
+++ new/Microline/XmL/Folder.c
@@ -932,7 +932,7 @@ LayoutTopBottom(XmLFolderWidget f, 
 	  tabFit = 0;
 	}
     }
-  
+
   for (i = 0; i < f->folder.tabCount; i++)
     {
       tab = f->folder.tabs[i];
@@ -953,6 +953,15 @@ LayoutTopBottom(XmLFolderWidget f, 
 	       XtVaSetValues(tab, XmNwidth, tgtTabWidth, NULL);
 	    }
 	}
+      else
+	{
+	  int thisTabWidth;
+	  XtVaGetValues(tab, XmNwidth, &thisTabWidth, NULL);
+	  if (thisTabWidth < f->folder.minTabWidth)
+	    XtVaSetValues(tab, XmNwidth, f->folder.minTabWidth, NULL);
+	  if (thisTabWidth > f->folder.maxTabWidth)
+	    XtVaSetValues(tab, XmNwidth, f->folder.maxTabWidth, NULL);
+	}
 
       fc = (XmLFolderConstraintRec *)(tab->core.constraints);
       
@@ -1658,7 +1667,7 @@ ConstraintInitialize(Widget req, 
       /* add child to tabs list */
       if (f->folder.tabAllocCount < f->folder.tabCount + 1)
 	{
-	  f->folder.tabAllocCount *= 2;
+	  f->folder.tabAllocCount += 32;
 	  f->folder.tabs = (Widget *)realloc((char *)f->folder.tabs,
 					     sizeof(Widget) * f->folder.tabAllocCount);
 	}
diff --quilt old/source/window.c new/source/window.c
--- old/source/window.c
+++ new/source/window.c
@@ -155,7 +155,7 @@ static Pixmap createBitmapWithDepth(Widg
 	unsigned int height);
 static WindowInfo *getNextTabWindow(WindowInfo *window, int direction,
         int crossWin, int wrap);
-static Widget addTab(Widget folder, const char *string);
+static Widget addTab(Widget folder, const char *string, int isNewTabTab);
 static int compareWindowNames(const void *windowA, const void *windowB);
 static Widget manageToolBars(Widget toolBarsForm);
 static void hideTearOffs(Widget menuPane);
@@ -602,7 +602,7 @@ WindowInfo *CreateWindow(const char *nam
     /* create the tab bar */
     window->tabBar = XtVaCreateManagedWidget("tabBar", 
        	    xmlFolderWidgetClass, tabForm,
-	    XmNresizePolicy, XmRESIZE_PACK,
+            XmNresizePolicy, XmRESIZE_DYNAMIC,
 	    XmNleftAttachment, XmATTACH_FORM,
             XmNleftOffset, 0,
 	    XmNrightAttachment, XmATTACH_WIDGET,
@@ -611,6 +611,7 @@ WindowInfo *CreateWindow(const char *nam
             XmNbottomAttachment, XmATTACH_FORM,
             XmNbottomOffset, 0,
             XmNtopAttachment, XmATTACH_FORM,
+            XmNmaxTabWidth, 96,
 	    NULL);
 
     window->tabMenuPane = CreateTabContextMenu(window->tabBar, window);
@@ -630,7 +631,8 @@ WindowInfo *CreateWindow(const char *nam
     XtAddCallback(window->tabBar, XmNactivateCallback,
     	    raiseTabCB, NULL);
 
-    window->tab = addTab(window->tabBar, name);
+    addTab(window->tabBar, " + ", True);
+    window->tab = addTab(window->tabBar, name, False);
 
     /* A form to hold the stats line text and line/col widgets */
     window->statsLineForm = XtVaCreateWidget("statsLineForm",
@@ -839,19 +841,23 @@ static void tabClickEH(Widget w, XtPoint
 /*
 ** add a tab to the tab bar for the new document.
 */
-static Widget addTab(Widget folder, const char *string)
+static Widget addTab(Widget folder, const char *string, int isNewTabTab)
 {
     Widget tooltipLabel, tab;
-    XmString s1;
+    XmString s1, s2;
 
     s1 = XmStringCreateSimple((char *)string);
+    if (isNewTabTab)
+        s2 = XmStringCreateSimple("New Document");
+    else
+        s2 = s1;
     tab = XtVaCreateManagedWidget("tab",
 	    xrwsBubbleButtonWidgetClass, folder,
 	    /* XmNmarginWidth, <default@nedit.c>, */
 	    /* XmNmarginHeight, <default@nedit.c>, */
   	    /* XmNalignment, <default@nedit.c>, */
   	    XmNlabelString, s1,
-  	    XltNbubbleString, s1,
+            XltNbubbleString, s2,
 	    XltNshowBubble, GetPrefToolTips(),
 	    XltNautoParkBubble, True,
 	    XltNslidingBubble, False,
@@ -859,6 +865,8 @@ static Widget addTab(Widget folder, cons
 	    /* XltNbubbleDuration, 8000,*/
 	    NULL);
     XmStringFree(s1);
+    if (isNewTabTab)
+        XmStringFree(s2);
 
     /* there's things to do as user click on the tab */
     XtAddEventHandler(tab, ButtonPressMask, False, 
@@ -882,10 +890,23 @@ static Widget addTab(Widget folder, cons
     AddTabContextMenuAction(tab);
 #endif /* LESSTIF_VERSION */
 
-    if (GetPerfDragDropTabs()) {
+    if (GetPerfDragDropTabs() && !isNewTabTab) {
         addTabDragAction(tab);
         registerDropSite(tab);
     }
+
+    /* maintain newTab-tab as last tab in tablist */
+    if (!isNewTabTab) {
+        WidgetList tabList;
+        int tabCount;
+        Widget t;
+        XtVaGetValues(folder, XmNtabWidgetList, &tabList,
+                      XmNtabCount, &tabCount, NULL);
+        t = tabList[tabCount - 1];
+        tabList[tabCount - 1] = tabList[tabCount - 2];
+        tabList[tabCount - 2] = t;
+    }
+
     return tab;
 }
 	    
@@ -937,7 +958,7 @@ void SortTabBar(WindowInfo *window)
     XtVaGetValues(window->tabBar, XmNtabWidgetList, &tabList,
                   XmNtabCount, &tabCount, NULL);
 
-    for (i=0, j=0; i<tabCount && j<nDoc; i++) {
+    for (i=0, j=0; i<(tabCount-1) && j<nDoc; i++) {
         if (tabList[i]->core.being_destroyed)
             continue;
 
@@ -2649,7 +2670,7 @@ static void saveYourselfCB(Widget w, Wid
     	XtVaGetValues(topWin->tabBar, XmNtabWidgetList, &tabs,
             	XmNtabCount, &tabCount, NULL);
 
-    	for (i=0; i< tabCount; i++) {
+        for (i=0; i< (tabCount-1); i++) {
 	    win = TabToWindow(tabs[i]);
             if (win->filenameSet) {
 		/* add filename */
@@ -3651,7 +3672,7 @@ WindowInfo* CreateDocument(WindowInfo* s
     /* Set the requested hardware tab distance and useTabs in the text buffer */
     BufSetTabDistance(window->buffer, GetPrefTabDist(PLAIN_LANGUAGE_MODE));
     window->buffer->useTabs = GetPrefInsertTabs();
-    window->tab = addTab(window->tabBar, name);
+    window->tab = addTab(window->tabBar, name, False);
 
     /* add the window to the global window list, update the Windows menus */
     InvalidateWindowMenus();
@@ -3724,7 +3745,7 @@ static WindowInfo *getNextTabWindow(Wind
     	    XtVaGetValues(win->tabBar, XmNtabWidgetList, &tabList,
             	    XmNtabCount, &tabCount, NULL);
 	    
-    	    for (i=0; i< tabCount; i++) {
+            for (i=0; i< (tabCount-1); i++) {
 	    	tabs[tabTotalCount++] = tabList[i];
 	    }
 	}
@@ -3734,7 +3755,7 @@ static WindowInfo *getNextTabWindow(Wind
     	XtVaGetValues(window->tabBar, XmNtabWidgetList, &tabList,
             	XmNtabCount, &tabCount, NULL);
 
-    	for (i=0; i< tabCount; i++) {
+        for (i=0; i< (tabCount-1); i++) {
 	    if (TabToWindow(tabList[i]))    /* make sure tab is valid */
 	    	tabs[tabTotalCount++] = tabList[i];
 	}
@@ -3782,7 +3803,7 @@ int getTabPosition(Widget tab)
     XtVaGetValues(tabBar, XmNtabWidgetList, &tabList,
             XmNtabCount, &tabCount, NULL);
 
-    for (i=0; i< tabCount; i++) {
+    for (i=0; i< (tabCount-1); i++) {
     	if (tab == tabList[i])
 	    return i;
     }
@@ -5000,10 +5021,18 @@ static void raiseTabCB(Widget w, XtPoint
     XmLFolderCallbackStruct *cbs = (XmLFolderCallbackStruct *)callData;
     WidgetList tabList;
     Widget tab;
+    int tabCount;
 
-    XtVaGetValues(w, XmNtabWidgetList, &tabList, NULL);
-    tab = tabList[cbs->pos];
-    RaiseDocument(TabToWindow(tab));
+    XtVaGetValues(w, XmNtabWidgetList, &tabList, XmNtabCount, &tabCount, NULL);
+    if (cbs->pos < (tabCount-1)) {
+        tab = tabList[cbs->pos];
+        RaiseDocument(TabToWindow(tab));
+    } else {
+        WindowInfo *window = GetTopDocument(w);
+        EditNewFile(window, NULL, False, NULL, window->path, False);
+        CheckCloseDim();
+        cbs->allowActivate = 0;
+    }
 }
 
 static Widget containingPane(Widget w)
diff --quilt old/Microline/XmL/Makefile.common new/Microline/XmL/Makefile.common
--- old/Microline/XmL/Makefile.common
+++ new/Microline/XmL/Makefile.common
@@ -7,7 +7,7 @@
 .c.o:
 	$(CC) -c -I.. $(CFLAGS) -o $@ $<
 
-OBJS = Folder.o XmL.o 
+OBJS = XmL.o Folder.o Grid.o GridUtil.o Progress.o Tree.o
 
 all: libXmL.a
 
diff --quilt old/Microline/XmL/Makefile.dependencies new/Microline/XmL/Makefile.dependencies
--- old/Microline/XmL/Makefile.dependencies
+++ new/Microline/XmL/Makefile.dependencies
@@ -1,2 +1,6 @@
 XmL.o: XmL.c XmL.h
 Folder.o: Folder.c Folder.h FolderP.h XmL.h
+Grid.o: Grid.c Grid.h GridP.h XmL.h
+GridUtil.o: GridUtil.c Grid.h GridP.h XmL.h
+Progress.o: Progress.c Progress.h ProgressP.h XmL.h
+Tree.o: Tree.c Tree.h TreeP.h XmL.h
